var lockUI    = false;
var uploading = false;
var upgrading = false;
var elapsed   = 0;
var count     = 60;

function changeInputFocus(id) {
    var str    = id;
    var idName = str.substring(0, str.length - 1);
    var idNo   = str.substring(str.length - 1, str.length);
    //alert("idName: " + idName + ", idNo: " + idNo);

    if(idNo < 3) {
        idNo++;
    } else {
        idNo = 0;
        if(idName == "cfg_ipaddr") {
            idName = "cfg_netmask";
        } else if(idName == "cfg_netmask") {
            idName = "cfg_gw";
        } else if(idName == "cfg_gw") {
            idName = "cfg_ipaddr";
        }
    }
    document.getElementById(idName + idNo).focus();
    document.getElementById(idName + idNo).select();
}

function checkIPAddr(id, text) {
    var dot_regex = /\w+\.$/;
    if(dot_regex.test(text.value)) {
        changeInputFocus(id);
    }

    var re = /^[0-9]+$/;
    if (!re.test(text.value)) {
        var str = text.value;
        var regex = /\D+|\s/gi;
        str = str.replace(regex, "");
        document.getElementById(id).value = str;
    } else if(text.value > 255) {
        document.getElementById(id).value = 255;
    } else if(text.value == "00" || text.value == "000") {
        document.getElementById(id).value = 0;
    }

    var str = document.getElementById(id).value; //find 012 pattern
    var zero_regex = /^0/;
    if(zero_regex.test(str)) {
        document.getElementById(id).value = Number(str)
    }
}

function detectBrowser() {
    var sAgent = navigator.userAgent.toLowerCase();
    this.isIE = (sAgent.indexOf("msie")     != -1); //IE6.0-7
    this.isFF = (sAgent.indexOf("firefox")  != -1); //firefox
    this.isSa = (sAgent.indexOf("safari")   != -1); //safari
    this.isOp = (sAgent.indexOf("opera")    != -1); //opera
    this.isNN = (sAgent.indexOf("netscape") != -1); //netscape
    this.isGc = (sAgent.indexOf("chrome")   != -1); //netscape
    this.isMa = this.isIE;                          //maxthon
    this.isOther = (!this.isIE && !this.isFF && !this.isSa && !this.isOp && !this.isNN && !this.isSa && !this.isGc); //unknown Browser
}

function selectWiFiSecurityMode() {
    var obj = document.getElementById("cfg_wifi_ssid_list");
    var ssidValue = obj.value;
    if(!ssidValue)
        return;

    if(ssidValue == 0) {
        document.getElementById("cfg_wifi_ssid").value = obj.options[obj.selectedIndex].text;
        document.getElementById("cfg_wifi_security_no").checked  = true;
    } else if(ssidValue == 1) {
        document.getElementById("cfg_wifi_ssid").value = obj.options[obj.selectedIndex].text;
        document.getElementById("cfg_wifi_security_wep").checked = true;
    } else if(ssidValue == 2) {
        document.getElementById("cfg_wifi_ssid").value = obj.options[obj.selectedIndex].text;
        document.getElementById("cfg_wifi_security_wpa").checked = true;
    }
}

function checkUploadComplete() {
    if (uploading == false)
        return;

    if (elapsed >= 300000) {
        alert("Timeout!");
    } else {
        setTimeout(checkUploadComplete, 2000);
        elapsed += 2000;
    }
}

function startUpload() {
    if(lockUI)
        return;

    var filename = document.fUpgrade.filename.value; //get input file
    if (filename != '' && !lockUI) {
        if (!uploading && (confirm("Upgrade firmware?")==true)) {
            lockUI = true;
            var iFrame = document.getElementById("iframeupload");
            var iFrameDoc = iFrame.contentDocument ? iFrame.contentDocument : iFrame.contentWindow.document;

            uploading = true;
            elapsed = 0;

            checkUploadComplete();
        } else {
            alert("User cancels firmware upload.");
            window.location.reload(true);
            return false;
        }
    } else {
        alert("Please select a firmware file.");
        return false;
    }
}

function uploadComplete() {
    if (!uploading)
        return;

    elapsed = 0;
    uploading = false;

    try {
        var iFrame = document.getElementById("iframeupload");
        var iFrameDoc = iFrame.contentDocument ? iFrame.contentDocument : iFrame.contentWindow.document;
        //alert("Upload OK!!");

        clearTimeout(timer);

        var t = new Date();
        var hostStr = "http://" + location.host + "/dev/info.cgi?action=upgrade" + "&t="  + t.getSeconds() + t.getMinutes();
        ajaxSendRequest(hostStr, true, onRcvDataUpgrade);
    } catch (e) {
        alert("Upload Fail: " + e);
    }
}

//check browser fot creating XMLHttpRequest object.
function createAJAX() {
    if (window.XMLHttpRequest) {
        return new XMLHttpRequest();
    } else if (window.ActiveXObject) {
        try {
            return new ActiveXObject("Msxml2.XMLHTTP");
        } catch (e) {
            try {
                return new ActiveXObject("Microsoft.XMLHTTP");
            } catch (e2) {
                return null;
            }
        }
    } else {
        return null;
    }
}

function onRcvDataUpgrade() {
    if (ajax.readyState == 4) {
        if (ajax.status == 200) {
            rebootSystem();
            window.stop ? window.stop() : document.execCommand("Stop");
        } else {
            alert("onRcvData error: " + ajax.responseText);
        }
    }
}

function ajaxSendRequest(uri, isRcved, callback) {
    ajax = createAJAX();
    if (!ajax) {
        alert("Create ajax object error");
        return 0;
    }

    if(isRcved)
        ajax.onreadystatechange = callback;

    ajax.open("GET", uri, true);
    ajax.send(null);
}

function doAjaxSendRequestReboot() {
    var t = new Date();
    var hostStr = "http://" + location.host + "/dev/info.cgi?action=reboot&reboot=Reboot" + "&t=" + t.getSeconds() + t.getMinutes();
    ajaxSendRequest(hostStr, false);
}

function countDown() {
    count = count - 1;
    if (count <= 0) {
        clearInterval(counter);
        document.getElementById("timer").innerHTML = ""; // watch for spelling
        window.location.reload(true);
        return;
    }
    document.getElementById("timer").innerHTML = "Reload page after " + count + ' seconds';
}

function rebootSystem() {
    setTimeout("doAjaxSendRequestReboot()", 5);
    count = 60;
    var counter = setInterval(countDown, 1000);
    return true;
}

function ajaxSendRequestRebootCheck() {
    if(lockUI)
        return;

    if ((confirm("Do you want to reboot the device ?")==true)) {
        lockUI = true;
        var t = new Date();
        var hostStr = "http://" + location.host + "/dev/info.cgi?action=reboot&reboot=Reboot" + "&t=" + t.getSeconds() + t.getMinutes();
        ajaxSendRequest(hostStr, false);

        count = 60;
        var counter = setInterval(timer, 1000); //1000 will  run it every 1 second
        return true;
    } else {
        return false;
    }
}

function onRcvDataUpdateDHCP() {
    if (ajax.readyState == 4) {
        if (ajax.status == 200) {
            rebootSystem();
            alert("Update DHCP setting OK."); //response=" + ajax.responseText
            window.stop ? window.stop() : document.execCommand("Stop");
        } else {
            alert("onRcvData error: " + ajax.responseText);
        }
    }
}

function ajaxSendRequestResetCheck() {
    if(lockUI)
        return;

    if ((confirm("Do you want to reset to factory default?")==true)) {
        lockUI = true;
        var t = new Date();
        var resetStr = "http://" + location.host + "/dev/info.cgi?action=Reset&Reset=Reset" + "&t=" + t.getSeconds() + t.getMinutes();
        ajaxSendRequest(resetStr, false);

        var d = new Date();
        var rebootStr = "http://" + location.host + "/dev/info.cgi?action=reboot&reboot=Reboot" + "&t=" + d.getSeconds() + d.getMinutes();
        ajaxSendRequest(rebootStr, false);

        count = 60;
        var counter = setInterval(timer, 1000); //1000 will  run it every 1 second
        return true;
    } else {
        return false;
    }
}

function updateDHCPClick() {
    if(lockUI)
        return;

    if ((confirm("Do you want to update DHCP setting?")==true)) {
        lockUI = true;
        var t = new Date();
        var $dhcp = document.getElementById("cfg_dhcp").checked ? "&dhcp=on" : "";
        var $ipaddr0 = document.getElementById("cfg_ipaddr0").value;
        var $ipaddr1 = document.getElementById("cfg_ipaddr1").value;
        var $ipaddr2 = document.getElementById("cfg_ipaddr2").value;
        var $ipaddr3 = document.getElementById("cfg_ipaddr3").value;
        var $netmask0 = document.getElementById("cfg_netmask0").value;
        var $netmask1 = document.getElementById("cfg_netmask1").value;
        var $netmask2 = document.getElementById("cfg_netmask2").value;
        var $netmask3 = document.getElementById("cfg_netmask3").value;
        var $gw0 = document.getElementById("cfg_gw0").value;
        var $gw1 = document.getElementById("cfg_gw1").value;
        var $gw2 = document.getElementById("cfg_gw2").value;
        var $gw3 = document.getElementById("cfg_gw3").value;

        var hostStr = "http://" + location.host + "/dev/info.cgi?action=network"
        + $dhcp
        + "&ipaddr0=" + $ipaddr0 + "&ipaddr1=" + $ipaddr1 + "&ipaddr2=" + $ipaddr2 + "&ipaddr3=" + $ipaddr3
        + "&netmask0=" + $netmask0 + "&netmask1=" + $netmask1 + "&netmask2=" + $netmask2 + "&netmask3=" + $netmask3
        + "&gw0=" + $gw0 + "&gw1=" + $gw1 + "&gw2=" + $gw2 + "&gw3=" + $gw3
        + "&t=" + t.getSeconds() + t.getMinutes();

        //alert(hostStr);
        ajaxSendRequest(hostStr, true, onRcvDataUpdateDHCP);
        return true;
    } else {
        return false;
    }
}

function checkSoftAPPwd(pwd) {
    if (pwd.length == 0 || (pwd.length >= 8 && pwd.length <= 63)) {
        return true;
    } else {
        alert("Please check password length is 8~63 words");
        return false;
    }
}

function updateSoftAPClick() {
    if(lockUI)
        return;

    var $ssid = encodeURIComponent(encodeURIComponent(document.getElementById("cfg_softap_ssid").value));
    var $passwd = encodeURIComponent(encodeURIComponent(document.getElementById("cfg_softap_password").value));

    if($ssid .length > 0) {
        if (checkSoftAPPwd($passwd) == true && (confirm("Do you want to update SoftAP setting?")==true)) {
            lockUI = true;
            var t = new Date();
            if(document.getElementById("cfg_softap_security_yes").checked) {
                var $SecurityMode = "yes";
            } else if(document.getElementById("cfg_softap_security_no").checked) {
                var $SecurityMode = "no";
            }

            var hostStr = "http://" + location.host + "/dev/info.cgi?action=softap"
            + "&ssid=" + $ssid + "&password=" + $passwd + "&security=" + $SecurityMode
            + "&t=" + t.getSeconds() + t.getMinutes();

            //alert(hostStr);
            ajaxSendRequest(hostStr, false);

            count = 60;
            var counter = setInterval(timer, 1000); //1000 will  run it every 1 second
            return true;
        } else {
            return false;
        }
    } else {
        alert("The SoftAP ssid characters in length must be greater than 0.");
    }
}

function checkPwdInputKeyUp(id, text) {
    checkPwdRegExp(id, text);
}

function checkPwdInputChange(id, text) {
    checkPwdRegExp(id, text);
}

function checkPwdRegExp(id, text) {
    var re = /[0-9A-Za-z]+$/g;
    if (!re.test(text.value)) {
        var str = text.value;
        var regex = /\W+|\s|\_/g;
        str = str.replace(regex, "");
        document.getElementById(id).value = str;
    }
}

function checkMacAddrInputKeyUp(id, text) {
    checkMacAddrRegExp(id, text);
}

function checkMacAddrInputChange(id, text) {
    checkMacAddrRegExp(id, text);
}

function checkMacAddrRegExp(id, text) {
    var re = /^[0-9A-Fa-f]+$/gi;
    if (!re.test(text.value)) {
        var str = text.value;
        document.getElementById(id).value = str.substring(0, str.length - 1);
    }
}

function onRcvDataUpdateWifi() {
    if (ajax.readyState == 4) {
        if (ajax.status == 200) {
            rebootSystem();
            alert("Update WiFi setting OK."); //response=" + ajax.responseText
            window.stop ? window.stop() : document.execCommand("Stop");
        } else {
            alert("onRcvData error: " + ajax.responseText);
        }
    }
}

function updateWifiClick() {
    if(lockUI)
        return;

    var $ssid = encodeURIComponent(encodeURIComponent(document.getElementById("cfg_wifi_ssid").value));

    if($ssid.length > 0) {
        if (confirm("Do you want to update WiFi setting?")==true) {
            lockUI = true;
            var t = new Date();
            var $passwd = encodeURIComponent(encodeURIComponent(document.getElementById("cfg_wifi_password").value));

            if(document.getElementById("cfg_wifi_security_no").checked) {
                var $SecurityMode = "nosecu";
            } else if(document.getElementById("cfg_wifi_security_wep").checked) {
                var $SecurityMode = "wep";
            } else if(document.getElementById("cfg_wifi_security_wpa").checked) {
                var $SecurityMode = "wpapsk";
            }

            var hostStr = "http://" + location.host + "/dev/info.cgi?action=wifi"
            + "&ssid=" + $ssid + "&password=" + $passwd + "&security=" + $SecurityMode
            + "&t=" + t.getSeconds() + t.getMinutes();

            //alert(hostStr);
            ajaxSendRequest(hostStr, true, onRcvDataUpdateWifi);
            return true;
        } else {
            return false;
        }
    } else {
        alert("The WiFi ssid characters in length must be greater than 0.");
    }
}

function onRcvDataUpdateMacAddr() {
    if (ajax.readyState == 4) {
        if (ajax.status == 200) {
            rebootSystem();
            alert("Update mac address setting OK.");
            window.stop ? window.stop() : document.execCommand("Stop");
        } else {
            alert("onRcvData error: " + ajax.responseText);
        }
    }
}

function checkMacAddrExpression() {
    for(var i = 0; i < 6; i++) {
        var s = document.getElementById("macaddr" + i).value;
        if(s.length > 0 && s.length == 1)
            document.getElementById("macaddr" + i).value = '0' + s;
    }
}

function updateMacAddrClick() {
    if(lockUI)
        return;

    checkMacAddrExpression();

    var mac_array = new Array();
    for(var i = 0; i < 6; i++)
        mac_array[i] = document.getElementById("macaddr" + i).value;

    var exited = false;
    for(var i = 0; i < 6; i++)
        if(mac_array[i].length != 2) {
            alert("Please check " + (i + 1) + " of 6 number in mac address, it is invalid.");
            exited = true;
        }

    if(exited)
        return;


    if (confirm("Do you want to update mac address setting?")==true) {
        lockUI = true;
        var t = new Date();
        var hostStr = "http://" + location.host + "/dev/info.cgi?action=macaddr";
        var str = "";
        for(var i = 0; i < 6; i++)
            str += "&macaddr" + i + "=" + mac_array[i];

        hostStr += str + "&t=" + t.getSeconds() + t.getMinutes();
        //alert(hostStr);
        ajaxSendRequest(hostStr, true, onRcvDataUpdateMacAddr);
        return true;
    } else {
        return false;
    }

}
